using FLY.Thick.Base.Client;
using FLY.Thick.Base.IService;
using MultiLayout;
using MultiLayout.UiModule;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using Unity;

namespace FLY.Thick.Base.UI.UiModule
{
    /// <summary>
    /// DynAreaSample.xaml 的交互逻辑
    /// </summary>
    public partial class DynAreaSample : UserControl
    {
        static NLog.Logger logger = NLog.LogManager.GetCurrentClassLogger();
        IUnityContainer container;
        PgGetSampleVm viewModel;

        public DynAreaSample()
        {
            InitializeComponent();
        }
        [InjectionMethod]
        public void Init(IUnityContainer container, IGetSampleService getSampleService)
        {
            viewModel = new PgGetSampleVm();
            viewModel.Init(getSampleService,null);

            this.container = container;
            
            this.DataContext = viewModel;
        }
        private void Border_Sample_Click(object sender, RoutedEventArgs e)
        {
            var p = container.Resolve<PgGetSample>();
            //PgGetSample p = new PgGetSample();
            //container.BuildUp(p);
            FlyLayoutManager.NavigationService.Navigate(p);
        }
    }


    public class UiModule2_DynAreaSample : IUiModule2
    {
        /// <summary>
        /// 控件标题
        /// 它的值取决于culture
        /// </summary>
        public string Title => "样品状态";

        public ComponentType Type => ComponentType.DynArea;

        public bool IsUnique => true;

        /// <summary>
        /// 控件
        /// 创建时，需要给它唯一ID，让加载自己的数据
        /// </summary>
        /// <param name="id"></param>
        /// <returns></returns>
        public FrameworkElement GetComponent(int id, IUnityContainer container)
        {
            DynAreaSample graph = new DynAreaSample();
            container.BuildUp(graph);
            return graph;
        }

    

        /// <summary>
        /// 控件缩略图，用于编辑界面时，大致看看
        /// 创建时，需要给它唯一ID，让加载自己的数据
        /// </summary>
        /// <param name="id"></param>
        /// <returns></returns>
        public FrameworkElement GetThumbnail()
        {
            return new System.Windows.Controls.Grid();
        }


        /// <summary>
        /// 给出全部控件ID, 控件自行删除没有的参数
        /// </summary>
        /// <param name="IDs"></param>
        public void MatchParam(int[] IDs)
        {

        }
    }
}
